"""
Install OpenERP on an (existing) empty database.
"""
import os

import openerp

def run(args):
    assert args.database
    config = openerp.tools.config
    if args.all_modules:
        if os.path.exists("../../addons/trunk"): # TODO not hardcoded addons-path
            module_names = list(set(os.listdir("../../addons/trunk")))
            [n in module_names and module_names.remove(n) and f(n) for n in args.exclude]
            config['init'] = dict.fromkeys(module_names, 1)
            config['addons_path'] = "../../addons/trunk"
    openerp.modules.registry.RegistryManager.get(
        args.database, update_module=True, pooljobs=False)

def add_parser(subparsers):
    parser = subparsers.add_parser('install',
        description='Create and initialize a new OpenERP database.')
    parser.add_argument('-d', '--database', metavar='DATABASE', required=True,
        help='the database to create')
    parser.add_argument('--all-modules', action='store_true',
        help='install all visible modules')
    parser.add_argument('--exclude', metavar='MODULE', action='append',
        help='exclude a module from installation (this option can be repeated)')

    parser.set_defaults(run=run)
