"""
Display information about a given model.
"""
import os

import openerp

def run(args):
    assert args.database
    assert args.model
    print "Fields (model `%s`, database `%s`):" % (args.model, args.database)
    openerp.tools.config['log_level'] = 100
    openerp.netsvc.init_logger()
    registry = openerp.modules.registry.RegistryManager.get(
        args.database, update_module=False, pooljobs=False)
    model = registry.get(args.model)
    max = 1
    for k, v in model._columns.items():
        max = len(k) if max < len(k) else max
    for k, v in sorted(model._columns.items()):
        print k.ljust(max + 2), v._type

def add_parser(subparsers):
    parser = subparsers.add_parser('model',
        description='Display information about a given model for an existing database.')
    parser.add_argument('-d', '--database', metavar='DATABASE', required=True,
        help='the database to connect to')
    parser.add_argument('-m', '--model', metavar='MODEL', required=True,
        help='the model for which information should be displayed')

    parser.set_defaults(run=run)
