import os
import sys

def run(args):

    import unittest2
    import openerp

    config = openerp.tools.config
    config['db_name'] = args.database

    import openerp.tests

    if args.create:
        # This test suite creates a database.
        unittest2.TextTestRunner(verbosity=2).run(
            openerp.tests.make_suite_no_db())
    else:
        # This test suite assumes a database.
        unittest2.TextTestRunner(verbosity=2).run(openerp.tests.make_suite())

def add_parser(subparsers):
    parser = subparsers.add_parser('run-tests',
        description='Run the test suite.')
    parser.add_argument('-d', '--database', metavar='DATABASE', required=True,
        help='the database to test')
    parser.add_argument('--create', action='store_true',
        help='Run a different suite, which creates a database. '
        'Without this flag, the database should already exists.')

    parser.set_defaults(run=run)
